/***************************************************************************
 *   Copyright (C) 2005-2006 Gao Xianchao                                  *
 *                 2007 Gao Xianchao gnap_an linux_lyb ahlongxp            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*
 * Author:	gxc
 * Create data:	2005-10-07 20:09
 */
 
#ifndef TRACKERMANAGER_H_
#define TRACKERMANAGER_H_

#include <pthread.h>
#include <list>
#include "BitStorm.h"

typedef std::list<ITracker*> TTrackerList;

class CTrackerManager : public ITrackerManager
{
public:
	CTrackerManager();
	virtual ~CTrackerManager();
private:
	pthread_t _thrHandle;
	bool _toExit;
	IBTTask* _task;
	unsigned int _peerCount;
	unsigned int _seedCount;
	TTrackerList _trackerList;
private:
	void createTrackers();	
	void stopTrackers();	
	void destroyTrackers();
public:
	void setBTTask(IBTTask* task);
	IBTTask* getBTTask();
	
 	bool start();
	void stop();		
	int getSeedCount();
	int getPeerCount();	
	
	int svc();
};

#endif /*TRACKERMANAGER_H_*/
